/*
 * time.c
 *
 *  Created on: 17.01.2016
 *      Author: wn
 */
#include <msp430g2553.h>
#include <signal.h>
#include <stdint.h>

#include "engine.h"


volatile uint32_t tickCnt = 0;
const uint16_t TICK = 1024;
uint16_t pwmVal = 512;
volatile uint16_t onTime = 500;
volatile uint16_t offTime = 200;

interrupt (TIMER0_A0_VECTOR) timer0a0_isr(void) {
	static uint8_t state = 0;
	static uint16_t timestamp = 0;

	timestamp++;

	switch (state) {
	case 0:
		if (timestamp >= onTime) {
			timestamp = 0;
			P1SEL &= ~BIT6;
			P1OUT &= ~BIT6;
			state = 1;
		}
		break;
	case 1:
		if (timestamp >= offTime) {
			timestamp = 0;
			P1SEL |= BIT6;
			state = 0;
		}
		break;
	default:
		state = 0;
	}


}


void engineInit() {
	P1DIR |= BIT6;
	P1OUT &= ~BIT6;
	P1SEL |= BIT6;
//
	TACCR0 = TICK;
	TACCR1 = 0;
//
	TACCTL0 = CCIE;
	TACCTL1 = OUTMOD_7;
	//TACTL = MC_1 | ID_0 | TASSEL_2 | TACLR | TAIE;
	TACTL = MC_1 | ID_0 | TASSEL_2 | TACLR;
}


uint16_t engineMaxPwmValue() {
	return TICK;
}

void engineSetPwmValue(uint16_t val) {
	TACCR1 = val;
}
